package com.muchinfo.mtp3pojos.exportconverter;

import com.alibaba.excel.converters.Converter;
import com.alibaba.excel.enums.CellDataTypeEnum;
import com.alibaba.excel.metadata.GlobalConfiguration;
import com.alibaba.excel.metadata.data.ReadCellData;
import com.alibaba.excel.metadata.data.WriteCellData;
import com.alibaba.excel.metadata.property.ExcelContentProperty;

public class ModifyStatusConverter implements Converter<Integer> {

    private static final String NO_CHANGE = "未变更";
    private static final String UNDER_CHANGE = "变更中";
    private static final String NO_REVIEW = "变更待审核";
    private static final String PENDING_REVIEW = "变更待复核";

    @Override
    public Class<?> supportJavaTypeKey() {
        // 实体类中对象属性类型
        return Integer.class;
    }

    @Override
    public CellDataTypeEnum supportExcelTypeKey() {
        // Excel中对应的CellData属性类型
        return CellDataTypeEnum.STRING;
    }

    @Override
    public Integer convertToJavaData(ReadCellData<?> cellData, ExcelContentProperty contentProperty, GlobalConfiguration globalConfiguration) throws Exception {
        // 从Cell中读取数据
        String gender = cellData.getStringValue();
        // 判断Excel中的值，将其转换为预期的数值
        if (NO_CHANGE.equals(gender)) {
            return 1;
        } else if (UNDER_CHANGE.equals(gender)) {
            return 2;
        } else if (NO_REVIEW.equals(gender)) {
            return 3;
        } else if (PENDING_REVIEW.equals(gender)) {
            return 4;
        }
        return null;
    }

    @Override
    public WriteCellData<?> convertToExcelData(Integer integer, ExcelContentProperty contentProperty, GlobalConfiguration globalConfiguration) throws Exception {
        // 判断实体类中获取的值，转换为Excel预期的值，并封装为CellData对象
        if (integer == null) {
            return new WriteCellData<>("");
        } else if (integer == 1) {
            return new WriteCellData<>(NO_CHANGE);
        } else if (integer == 2) {
            return new WriteCellData<>(UNDER_CHANGE);
        } else if (integer == 3) {
            return new WriteCellData<>(NO_REVIEW);
        } else if (integer == 4) {
            return new WriteCellData<>(PENDING_REVIEW);
        }
        return new WriteCellData<>("");
    }
}
